/////////////////////////////////////////////////////////////////////////////////
// MAIN.C - Adventure 'A' (Planet Of Death) for BlackBerry 850, 950, 857 and 957
// Ported by Athlor (athlor@gmail.com) based on Generic C version by Paul Taylor
/////////////////////////////////////////////////////////////////////////////////
#include <pager.h>
#include <ribbon.h>
#include "icon.h"
#include "adv_a.h"

char VersionPtr[] = "Planet Of Death";
int AppStackSize = 3000;

MESSAGE MSG;
LcdConfig LcdCfg;
HandleType H; FileType F; // File I/O

void puts(char *s)
{
  LcdPutStringXY(0,LcdCfg.height-8,s,-1,0);
  LcdScroll(8);
}

int _getch(void)
{
  while(RimGetMessage(&MSG),MSG.Event!=KEY_DOWN);
  return MSG.SubMsg;
}

void GetLine(void)
{
  char NC=0; chaEditLine[NC]=0; // Clear line buffer
  do{
    LcdPutStringXY(0,LcdCfg.height-8,chaEditLine,-1,0); // Command line
    LcdPutStringXY(-1,-1," ",1,TEXT_INVERT);            // Cursor
    LcdClearToEndOfLine();
    RimGetMessage(&MSG);
    if(MSG.Event==KEY_DOWN) {
      if(MSG.SubMsg==KEY_ESCAPE) {
        RibbonShowRibbon();
        RimTerminateThread();} // Exit program
      if(MSG.SubMsg==KEY_BACKSPACE) {
        if(NC>0) chaEditLine[--NC]=0;
      } else {
        if(MSG.SubMsg!=KEY_ENTER) chaEditLine[NC++]=MSG.SubMsg;
        chaEditLine[NC]=0;
      }
    }
  } while(MSG.SubMsg!=KEY_ENTER);
  LcdPutStringXY(0,LcdCfg.height-8,chaEditLine,-1,0);
  LcdClearToEndOfLine(); // Erase Cursor
  LcdScroll(8);
}

void Wrap(char *s) // From Cybiko
{
 char l[64]; int i; int lsp;
  while(LcdGetStringWidth(s,-1,-1)>155)
  {
    i=0; l[i]=0;
    do {
      if(*s==32)  lsp=i; // Remember last space
      l[i++] = *s++; l[i]=0;
    }while(LcdGetStringWidth(l,-1,-1)<155&&(l[i-1]!='\n'));
    if(*(s-1)!='\n') {s=s-(i-lsp)+1; i=lsp; l[i++]='\n'; l[i]=0;}
    puts(l);
  }
  puts(s);
}

void ShowRoom(void)
{
  int nItem;
  Wrap(straRoom[CUR_RM]);
  FLAG = FALSE;
  for (nItem = 0; nItem < MAX_ITEM; ++nItem) {
    if (naItemLoc[nItem] == CUR_RM) {
      if (!FLAG) {
        puts("I can also see:");
        FLAG = TRUE;
      }
      Wrap(straItem[nItem]);
    }
  }
  nNextParseAction = NA_DO_AUTO;
}

void SH_TELL(void)
{
  int GET_TOK(); // <<< INLINE PROTOTYPE
  BYTE *pDirections;

  if (GVARS[GVAR_02] > 0) --GVARS[GVAR_02];
  if (GVARS[GVAR_05] > 0) --GVARS[GVAR_05];

  /***
  {
    char sz[256];
    sprintf(sz, "02 = %u\n", GVARS[0x02]);
    puts(sz);
  }
  ***/

  puts("Tell me what to do:"); // Main game prompt

  GetLine(); // Input line of text
  F_NTYET = FALSE;

// ======================================================================
// fetch verb token from the input buffer
// ======================================================================
  pchEditLine = chaEditLine;

  for (;;) {
    VERB_TK = GET_TOK();
    if (VERB_TK == 0xff) {
      BOOL bDont = FALSE;
      if ((*pchEditLine == '\n')||(*pchEditLine == '\0'))
        bDont = TRUE;
      else {
        for (;;) {
          if (*pchEditLine == ' ') {
            ++pchEditLine;
            goto verb_outer_continue;
          } else if ((*pchEditLine == '\n')||(*pchEditLine == '\0')) {
            bDont = TRUE;
            break;
          }
          ++pchEditLine;
        }
      }
      if (bDont) {
        puts("I dont understand.");
        nNextParseAction = NA_DO_AUTO;
        return;
      }
    } else break; // verb ok

verb_outer_continue:
    continue;
  }
  // verb recognized
  NOUN_TK = 0xff; // assume noun unrecognized before reading on
  
  for (;;) { // Trim off excess characters from verb
    char ch = *pchEditLine;
    if (ch == ' ') break;
    if (ch == '\0') goto P_DIR;
    if (ch == '\n') goto P_DIR;
    ++pchEditLine;
  }

// ======================================================================
// fetch noun token from the input buffer
// ======================================================================
  for (;;) {
    ++pchEditLine;
    NOUN_TK = GET_TOK();
    if (NOUN_TK != 0xff) break;
    for (;;) { // Trim off excess characters from noun
      char ch = *pchEditLine;
      if (ch == ' ') break;
      if (ch == '\0') goto P_DIR;
      if (ch == '\n') goto P_DIR;
      ++pchEditLine;
    }
  }

// ======================================================================
// attempt to parse a direction verb
// ======================================================================
P_DIR:
  pDirections = DIR_V[CUR_RM];
  for (;;) {
    int nDir = *pDirections;
    if (nDir == 0xff) break;
    if (nDir == VERB_TK) {
      CUR_RM = pDirections[1];
      nNextParseAction = NA_MAIN;
      return;
    }
    pDirections += 2;
  }
  pvndCurrent = vndDefinitions;
  CMDFLG = FALSE;
  nNextParseAction = NA_BEGIN;
}

void *SYS_V[]; // <<< INLINE PROTOTYPE

void PARSE_LP(void)
{
  int nVerbTok = pvndCurrent->nVerbTok;

  if (nVerbTok == 0) {
    if (!CMDFLG) {
      if (VERB_TK < TOK_GET)    // direction?
        puts("I can't go in that direction.");
      else if (F_NTYET)
        puts("I can't do that, yet.");
      else
        puts("I can't.");
    }
    nNextParseAction = NA_DO_AUTO;
    return;
  }
  if ((nVerbTok == 0xff)||(nVerbTok == VERB_TK)) {
    int nNounTok = pvndCurrent->nNounTok;

    if ((nNounTok == 0xff)||(nNounTok == NOUN_TK)) {
      int nPred;
      pPredicateCurrent = (BYTE *)pvndCurrent->pPredicates;
      while ((nPred = *pPredicateCurrent++) != 0xff) {
        BOOL(*pfn) () = PRED_V[nPred];
        PARAM1 = *pPredicateCurrent;
        if (!pfn()) {
          F_NTYET = TRUE;
          nNextParseAction = NA_CONTINUE;
          return;
        }
        ++pPredicateCurrent;
      }
      // Execute command
      pActionCurrent = (BYTE *)pvndCurrent->pActions;
      CMDFLG = TRUE;
      nNextParseAction = NA_CONTINUE;
      for (;;) {
        if (*pActionCurrent == 0xff) return;
        else {
          void (*pfn) () = (void *)(SYS_V[*pActionCurrent++]);
          PARAM1 = *pActionCurrent;
          pfn();
          if (nNextParseAction != NA_CONTINUE) return;
          ++pActionCurrent;
        }
      }
      puts("Executed!");
    }
  }
  nNextParseAction = NA_CONTINUE;
  return;
}

// PREDICATES

// predicate CHKROOM - this tests the current room number to make sure it's the specified room number.
// if it is, we move on to the next command, otherwise we trigger a "i can't do that yet" response.
// this handler interprets PARAM1 as the room number
BOOL CHKROOM(void)
{
  return PARAM1 == CUR_RM;
}

// predicate for GET and DROP commands
// this handler interprets PARAM1 as the item number
BOOL CHKHERE(void)
{
  int nLoc = naItemLoc[PARAM1];
  return (nLoc == CUR_RM)||(nLoc >= ITEM_WORN);
}

// predicate CHKRAND - randomly allows or disallows the user's command.
// if allowed, we move on to the next command, otherwise we trigger a "i can't do that yet" response.
BOOL CHKRAND(void)
{
  return (rand()%256) < PARAM1;
}

// predicate CHKAWAY - checks that the specified item is not carried, held or in the current room.
// if it is NOT, we move on to the next command, otherwise we trigger a "i can't do that yet" response.
// this handler interprets PARAM1 as the item number
BOOL CHKAWAY(void)
{
  return !CHKHERE();
}

// predicate CHKWORN - checks that the specified item is being worn.
// if it is, we move on to the next command, otherwise we trigger a "i can't do that yet" response.
// this handler interprets PARAM1 as the item number
BOOL CHKWORN(void)
{
  return naItemLoc[PARAM1] == ITEM_WORN;
}

// predicate CHKSETF - checks the game variable specified by PARAM1.
// if it is non-zero, we move on to the next command, otherwise we trigger a "i can't do that yet" response.
// this handler interprets PARAM1 as the game variable number
// used by "field" and "look up"
BOOL CHKSETF(void)
{
  return !!GVARS[PARAM1];
}

// predicate TSTGVAR - compares the game variable specified by PARAM1 with the value specified as
// the next byte after the command.
// if it is equal, we move on to the next command, otherwise we trigger a "i can't do that yet" response.
// this handler interprets PARAM1 as the game variable number
BOOL TSTGVAR(void)
{
  int nParam2 = *++pPredicateCurrent;
  return GVARS[PARAM1] == nParam2;
}

// predicate CHKCLRF - checks the game variable specified by PARAM1.
// if it is zero, we move on to the next command, otherwise we trigger a "i can't do that yet" response.
// this handler interprets PARAM1 as the game variable number
BOOL CHKCLRF(void)
{
  return !CHKSETF();
}

// predicate CHKHELD - checks that the specified item is being carried (or worn!).
// if it is, we move on to the next command, otherwise we trigger a "i can't do that yet" response.
// this handler interprets PARAM1 as the item number
BOOL CHKHELD(void)
{
  return (naItemLoc[PARAM1]==ITEM_HELD)||(naItemLoc[PARAM1]==ITEM_WORN);
}

/***
; fetch location for an item
; item number is in PARAM1
; location is returned in A
; address of location entry is returned in HL

GET_LOC ld      hl,naItemLoc
        ld      b,$00
        ld      c,(PARAM1)
        add     hl,bc
        ld      a,(hl)
        ret     
***/

void SH_INVE(void)
{
  int bNothing = TRUE;
  int nItem;
  int nLoc;

  puts("I have with me the following:");
  for (nItem = 0; nItem < MAX_ITEM; ++nItem) {
    nLoc = naItemLoc[nItem];
    if (nLoc>=ITEM_WORN) {
      bNothing = FALSE;
      Wrap(straItem[nItem]);
      if (nLoc==ITEM_WORN) puts("  which I am wearing.");
    }
  }
  if (bNothing) puts("Nothing at all.");
  nNextParseAction = NA_DO_AUTO;
}

// ======================================================================
// system command - REMOVE command
// item to be removed is specified in PARAM1
// ======================================================================
void SH_REMO(void)
{
  if (naItemLoc[PARAM1] == ITEM_WORN) {
    if (GVARS[GVAR_NO_ITEMS] == 6) {
      puts("I can't. My hands are full.");
      nNextParseAction = NA_DO_AUTO;
    } else {
      naItemLoc[PARAM1] = ITEM_HELD;
      ++GVARS[GVAR_NO_ITEMS];
    }
  } else {
    puts("I am not wearing it.");
    nNextParseAction = NA_DO_AUTO;
  }
}

// ======================================================================
// system command - GET command
// item to be got is specified in PARAM1
// ======================================================================
void SH_GET(void)
{
  if (GVARS[GVAR_NO_ITEMS] == 6) {
    puts("I can't carry any more.");
    nNextParseAction = NA_DO_AUTO;
  } else if (naItemLoc[PARAM1] == CUR_RM) {
    naItemLoc[PARAM1] = ITEM_HELD;
    ++GVARS[GVAR_NO_ITEMS];
  } else if ((naItemLoc[PARAM1]==ITEM_WORN)||(naItemLoc[PARAM1]==ITEM_HELD)) {
    puts("I already have it.");
    nNextParseAction = NA_DO_AUTO;
  } else {
    puts("I don't see it here.");
    nNextParseAction = NA_DO_AUTO;
  }
}

// ======================================================================
// system command - DROP command
// item to be dropped is specified in PARAM1
// ======================================================================
void SH_DROP(void)
{
  if (naItemLoc[PARAM1] == CUR_RM) {
    puts("I don't have it.");
    nNextParseAction = NA_DO_AUTO;
  } else if (naItemLoc[PARAM1] == ITEM_WORN) {
    naItemLoc[PARAM1] = CUR_RM;
  } else if (naItemLoc[PARAM1] == ITEM_HELD) {
    --GVARS[GVAR_NO_ITEMS];
    naItemLoc[PARAM1] = CUR_RM;
  } else {
    puts("I don't have it.");
    nNextParseAction = NA_DO_AUTO;
  }
}

// ======================================================================
// system command - WEAR command
// item to be worn is specified in PARAM1
// ======================================================================
void SH_WEAR(void)
{
  if (naItemLoc[PARAM1] == ITEM_HELD) {
    naItemLoc[PARAM1] = ITEM_WORN;
    --GVARS[GVAR_NO_ITEMS];
  } else if (naItemLoc[PARAM1] == ITEM_WORN) {
    puts("I am already wearing it.");
    nNextParseAction = NA_DO_AUTO;
  } else {
    puts("I don't have it.");
    nNextParseAction = NA_DO_AUTO;
  }
}

// ======================================================================
// system command - display a response
// index of response to be displayed is specified in PARAM1
// ======================================================================
BOOL SH_MSG(void)
{
  Wrap(straMsg[PARAM1]);
  return TRUE;
}

// ======================================================================
// system command - REDE
// redescribe current room, terminating execution of system commands
// ======================================================================
void SH_REDE(void)
{
  nNextParseAction = NA_MAIN;
}

// ======================================================================
// exactly the same effect as SH_FAIL - it halts further system command
// processing,
// and proceeds to execute the auto commands.
// ======================================================================
void SH_AUTO(void)
{
  nNextParseAction = NA_DO_AUTO;
}

// ======================================================================
// system command - go directly to specific room (do not pass go)
// index of room is specified in PARAM1
// NB: room description not automatically displayed
// ======================================================================
void SH_GOTO(void)
{
  CUR_RM = PARAM1;
}

// ======================================================================
// system command SETF - set game variable to $ff
// index of variable to set is specified in PARAM1
// ======================================================================
void SH_SETF(void)
{
  GVARS[PARAM1] = 0xff;
}

// ======================================================================
// System command CLRF - clear game variable to $00
// index of variable to clear is specified in PARAM1
// ======================================================================
void SH_CLRF(void)
{
  GVARS[PARAM1] = 0x00;
}

// ======================================================================
// System command - SWAP
// swap an item's location with the location of the following item
// item to be swapped is specified in PARAM1
// ======================================================================
void SH_SWAP(void)
{
  int nTemp = naItemLoc[PARAM1];
  naItemLoc[PARAM1] = naItemLoc[PARAM1 + 1];
  naItemLoc[PARAM1 + 1] = nTemp;
}

// ======================================================================
// System command - DEAD
// immediately terminate game, stop executing system commands
// ======================================================================
void SH_DEAD(void)
{
  RimSpeakerBeep(999,99,50,50);
  puts("Try again [y][n]?");

  for (;;) {
    char ch = _getch();
    if (ch == 'y') {
      nNextParseAction = NA_RESTART;
      return;
    }
    if (ch == 'n') {
      RibbonShowRibbon();
      RimTerminateThread();
    }
  }
}

// display "OK.." prompt and cease processing system commands
void SH_OK(void)
{
  puts("OK..");
  nNextParseAction = NA_DO_AUTO;
}

void SH_QUIT(void)
{
  puts("Save game [y][n]?");
  if (_getch() == 'y') {
    int i;
    H=DbGetHandle("Adv_A.dat");
    F=DbFileOpen(H, 256);
    for(i=0; i<=0x1e; ++i) DbFileWrite(F,&GVARS[i],4);
    for(i=0; i<MAX_ITEM; ++i) DbFileWrite(F,&naItemLoc[i],4);
    DbFileWrite(F,&CUR_RM,4); DbFileWrite(F,&nScore,4);
    DbFileClose(F,TRUE);
    puts("Continue game [y][n]?");
    if (_getch() == 'y') {
      nNextParseAction = NA_DO_AUTO;
      return;
    }
  }
  SH_DEAD();
}

// ======================================================================
// System command SETV - set game variable to a specific value
// index of variable to set is specified in PARAM1
// the new value is specified as the byte after this command
// ======================================================================
void SH_SETV(void)
{
  int nParam2 = *++pActionCurrent;
  GVARS[PARAM1] = nParam2;
}

// ======================================================================
// System command CREA - create item in current room
// index of item to be created is specified in PARAM1
// ======================================================================
void SH_CREA(void)
{
  naItemLoc[PARAM1] = CUR_RM;
}

// ======================================================================
// System command DEST - destroy item in current room
// index of item to be destoyed is specified in PARAM1
// ======================================================================
void SH_DEST(void)
{
  naItemLoc[PARAM1] = NOTX;
}

// clean-up and abort execution of system commands, continuing with auto commands
void SH_FAIL(void)
{
  nNextParseAction = NA_DO_AUTO;
}

// ======================================================================
// System command ADSC - add value to the current score.
// value to be added is specified in PARAM1
// ======================================================================
void SH_ADSC(void)
{
  nScore += PARAM1;
}

void SH_SCOR(void)
{
  char szScore[32];
  RimSprintf(szScore,31,"You have a score of %04x", nScore); // hex! (really)
  Wrap(szScore);
}

void *SYS_V[] = { // Addresses of various system function handlers
 SH_INVE, SH_REMO, SH_GET, SH_DROP, SH_WEAR, SH_MSG, SH_REDE, SH_AUTO,
 SH_GOTO, SH_SETF, SH_CLRF, SH_SWAP, SH_DEAD, SH_OK, SH_QUIT, SH_SETV,
 SH_CREA, SH_DEST, SH_ADSC, SH_SCOR, SH_FAIL, SH_TELL, SH_FAIL,
 SH_FAIL, SH_FAIL
};

// ======================================================================
// Fetch command token from the input buffer, starting at position HL
// on return, A contains the token code (or $ff if not recognized)
// and HL points to the character after the token
// ======================================================================
int GET_TOK(void)
{
  char *pchTokenBuffer = strTokenBuf;
  int nResult = 0xff;
  int n;

  strncpy(strTokenBuf, "    ", 4);  // Clear the token buffer w/ spaces
  for (n=0; n<4; ++n) {
    char ch = *pchEditLine;
    if (ch == ' ') break;
    if (ch == '\0') break;
    if (ch == '\n') break;
    *pchTokenBuffer++ = ch;
    ++pchEditLine;
  }
  for (n=0; n<MAX_TOK; ++n) {
    if (strncmp(strTokenBuf, taToken[n].strWord, 4)==0) {
      nResult = taToken[n].nCode;
      break;
    }
  }
  return nResult;
}

void Adv_AThread(void)
{
  int n;
  PID pid;
  pid.Name = VersionPtr;
  pid.EnableForeground = TRUE;
  pid.Icon = NULL;
  RimSetPID(&pid);
  LcdGetConfig(&LcdCfg);

  for (;;) { // Game loop
    for (n=0; n<=0x1e; ++n) GVARS[n]=0; // Initialize game variables
    nScore = 0;
    LcdClearDisplay();
    LcdCopyBitmapToDisplay(&IconBMP, 0, LcdCfg.height-24); // Show icon bmp
    Wrap("Welcome to Adventure 'A'\nThe Planet of Death\n\nIn this adventure you\
 find yourself stranded on an alien planet. Your aim is to escape from this\
 planet by finding your, now captured and disabled, space ship.\nYou will meet\
 various hazards and dangers on your adventure, some natural, some not, all of\
 which you must overcome to succeed."); puts("");
    puts("Good luck, You will need it!");
    _getch(); // Wait
    for (n=0; n<MAX_ITEM; ++n) naItemLoc[n]=naItemStart[n]; // Copy item locs
    CUR_RM = 0;
    puts("Restore game [y][n]?");
    if (_getch() == 'y') {
      H=DbGetHandle("Adv_A.dat"); // Saved game
      if(DbSize(H,TRUE)!=0) {
        F = DbFileOpen(H, 256);
        for (n=0; n<=0x1e; ++n) DbFileRead(F,&GVARS[n],4);        // Game Vars
        for (n=0; n<MAX_ITEM; ++n) DbFileRead(F,&naItemLoc[n],4); // Item locs
        DbFileRead(F,&CUR_RM,4); DbFileRead(F,&nScore,4);         // Room & Score
        DbFileClose(F,FALSE);
      } else { puts("NO SAVED GAME!"); _getch();}
    }

    for (;;) // Main loop
    {
      LcdClearDisplay();
      if (GVARS[0] == 0) {
        ShowRoom();
      } else {
        if (GVARS[3] > 0) --GVARS[3];
        if (naItemLoc[0] == CUR_RM) {
          ShowRoom();
        } else {
          Wrap("Everything is dark. I cant see.");
          if (GVARS[4] > 0) --GVARS[4];
          nNextParseAction = NA_DO_AUTO;
        }
      }
      for (;;) // Parse loop
      {
        switch (nNextParseAction) {
        case NA_DO_AUTO: pvndCurrent=AUT_LST; break;
        case NA_CONTINUE: ++pvndCurrent; break;
        case NA_MAIN:
        case NA_RESTART: goto outer_cont; break;
        case NA_BEGIN: break;
        default: puts("ERROR"); ++pvndCurrent; break;
        }
        PARSE_LP();
      }
outer_cont:
      if (nNextParseAction==NA_RESTART) break;
    } // Main loop
  }   // Game loop
}

void PagerMain(void)
{
  RibbonRegisterFunction(VersionPtr,&IconBMP,0,40,Adv_AThread,AppStackSize);
}


